<template>
  <component
    :is="to ? 'NuxtLink' : 'div'"
    :style="{ height: `${props.height}px`, width: `${props.width}px` }"
    class="position-relative"
    :to="to"
  >
    <b-img-lazy
      v-b-visible="callback"
      block
      :src="image"
      :alt="props.source.breed"
      blank
      blank-color="#bbb"
      :width="props.width"
      :height="props.height"
      :fluid="props.fluid"
      class="mx-auto"
    />
    <div v-if="!hideInformation" class="image-detail">
      <slot name="title">
        <h5>{{ props.source.breed }}</h5>
      </slot>
      <slot name="information">
        <p
          v-if="props.source.subtitle || props.subtitle"
          class="font-weight-light"
        >
          {{ props.source.subtitle || props.subtitle }}
        </p>
      </slot>
    </div>
  </component>
</template>

<script setup>
import { useStore } from '@nuxtjs/composition-api'
import { onMounted, ref, watch } from 'vue'

const props = defineProps({
  source: {
    type: Object,
    default: () => ({}),
  },
  isSubBreed: {
    type: Boolean,
    default: false,
  },
  subtitle: {
    type: String,
    default: '',
  },
  fluid: {
    type: Boolean,
    default: false,
  },
  width: {
    type: [Number, String],
    default: 300,
  },
  height: {
    type: [Number, String],
    default: 300,
  },
  imageSrc: {
    type: String,
    default: '',
  },
  hideInformation: {
    type: Boolean,
    default: false,
  },
  to: {
    type: String,
    default: null,
  },
})

const store = useStore()

const image = ref(null)

watch(
  () => props.imageSrc,
  (val) => {
    image.value = val
  }
)

const fetchImage = async () => {
  const dispatcher = props.isSubBreed
    ? 'dog_fetchSubBreedImageUrl'
    : 'dog_fetchBreedImageUrl'

  const data = await store.dispatch(`dog/${dispatcher}`, {
    breed: props.source.breed,
    subBreed: props.source.subBreed,
  })
  image.value = data
}

const callback = (visible) => {
  if (visible && !image.value && !props.imageSrc) {
    fetchImage()
  }
}

onMounted(() => {
  if (props.imageSrc) image.value = props.imageSrc
})
</script>

<style scoped>
.image-detail {
  position: absolute;
  background-color: #0000009e;
  bottom: 0;
  right: 0;
  left: 0;
  height: 30%;
  color: white;
  padding: 8px;
  text-transform: capitalize;
}
</style>
